"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .httpmetadata import HTTPMetadata, HTTPMetadataTypedDict
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unkey_py.types import BaseModel


class RatelimitSetOverrideRequestBodyTypedDict(TypedDict):
    identifier: str
    r"""Identifier of your user, this can be their userId, an email, an ip or anything else. Wildcards ( * ) can be used to match multiple identifiers, More info can be found at https://www.unkey.com/docs/ratelimiting/overrides#wildcard-rules"""
    limit: int
    r"""How many requests may pass in a given window."""
    duration: int
    r"""The window duration in milliseconds"""
    namespace_id: NotRequired[str]
    r"""The id of the namespace. Either namespaceId or namespaceName must be provided"""
    namespace_name: NotRequired[str]
    r"""Namespaces group different limits together for better analytics. You might have a namespace for your public API and one for internal tRPC routes. Wildcards can also be used, more info can be found at https://www.unkey.com/docs/ratelimiting/overrides#wildcard-rules"""
    async_: NotRequired[bool]
    r"""Async will return a response immediately, lowering latency at the cost of accuracy."""


class RatelimitSetOverrideRequestBody(BaseModel):
    identifier: str
    r"""Identifier of your user, this can be their userId, an email, an ip or anything else. Wildcards ( * ) can be used to match multiple identifiers, More info can be found at https://www.unkey.com/docs/ratelimiting/overrides#wildcard-rules"""

    limit: int
    r"""How many requests may pass in a given window."""

    duration: int
    r"""The window duration in milliseconds"""

    namespace_id: Annotated[Optional[str], pydantic.Field(alias="namespaceId")] = None
    r"""The id of the namespace. Either namespaceId or namespaceName must be provided"""

    namespace_name: Annotated[Optional[str], pydantic.Field(alias="namespaceName")] = (
        None
    )
    r"""Namespaces group different limits together for better analytics. You might have a namespace for your public API and one for internal tRPC routes. Wildcards can also be used, more info can be found at https://www.unkey.com/docs/ratelimiting/overrides#wildcard-rules"""

    async_: Annotated[Optional[bool], pydantic.Field(alias="async")] = False
    r"""Async will return a response immediately, lowering latency at the cost of accuracy."""


class RatelimitSetOverrideResponseBodyTypedDict(TypedDict):
    r"""Sucessfully created a ratelimit override"""

    override_id: str
    r"""The id of the override. This is used internally"""


class RatelimitSetOverrideResponseBody(BaseModel):
    r"""Sucessfully created a ratelimit override"""

    override_id: Annotated[str, pydantic.Field(alias="overrideId")]
    r"""The id of the override. This is used internally"""


class RatelimitSetOverrideResponseTypedDict(TypedDict):
    http_meta: HTTPMetadataTypedDict
    object: NotRequired[RatelimitSetOverrideResponseBodyTypedDict]
    r"""Sucessfully created a ratelimit override"""


class RatelimitSetOverrideResponse(BaseModel):
    http_meta: Annotated[Optional[HTTPMetadata], pydantic.Field(exclude=True)] = None

    object: Optional[RatelimitSetOverrideResponseBody] = None
    r"""Sucessfully created a ratelimit override"""
